require "rubygems" 
require "sinatra" 
require 'vendor/ofcl/lib/open_flash_chart_lazy'
require 'json'
require 'mash'
require 'json/add/rails'

pie =<<-EOS
  penetration = [["tv",40],["internet",10],["magazines",50]]
  pie_chart = OpenFlashChartLazy::Pie.new("Media")
  serie=OpenFlashChartLazy::Serie.new(penetration)
  pie_chart.add_serie(serie)
  pie_chart.title.text="My Chocolate Pie"
  pie_chart.title.style="{background-color:#000000;color:#ffffff;font-size:20px;}"
  pie_chart.bg_colour="#FFFFFF"
  pie_chart.elements[0][:alpha]=0.6
  pie_chart.elements[0][:stroke]=20
  pie_chart.elements[0][:border]=40
  pie_chart.to_json
EOS
bar =<<-EOS
  income = [["tv",40000],["internet",10000],["magazines",50000],["other",40000]]
  bar_chart = OpenFlashChartLazy::Bar.new("Income")
  topics=OpenFlashChartLazy::Serie.new(income,{:title=>"Media"})
  bar_chart.add_serie(topics)
  bar_chart.x_axis.labels.rotate="vertical"
  bar_chart.bg_colour="#FFFFFF"

  bar_chart.x_axis.colour="#808080"
  bar_chart.x_axis["grid-colour"]="#A0A0A0"
  bar_chart.x_axis.stroke=1

  bar_chart.y_axis.colour="#808080"
  bar_chart.y_axis.stroke=1
  bar_chart.y_axis["grid-colour"]="#A0A0A0"
  bar_chart.y_axis.min=0
  bar_chart.y_axis.max=80000
  bar_chart.y_axis.steps=25000
  bar_chart.to_json
EOS
bar3d =<<-EOS
  income = [["tv",40000],["internet",10000],["magazines",50000],["other",40000]]
  bar_chart = OpenFlashChartLazy::Bar3d.new("Income")
  topics=OpenFlashChartLazy::Serie.new(income,{:title=>"Media"})
  bar_chart.add_serie(topics)
  bar_chart.bg_colour="#FFFFFF"

  bar_chart.x_axis.colour="#808080"
  bar_chart.x_axis["grid-colour"]="#A0A0A0"
  # add this setting here because will be placed first to work
  bar_chart.x_axis["3d"]=10

  bar_chart.y_axis.colour="#808080"
  bar_chart.y_axis["grid-colour"]="#A0A0A0"
  bar_chart.y_axis.min=0
  bar_chart.y_axis.max=80000
  bar_chart.y_axis.steps=25000
  
  #adding tip an color to a bar
  bar_chart.elements.last.values[2]={"top"=> income[2][1], "colour"=> "#D54C78",:tip=>"look here"}
  
  bar_chart.to_json
EOS
line =<<-EOS
  line_graph = OpenFlashChartLazy::Line.new("Progress")
  active_users=OpenFlashChartLazy::Serie.new([["2008-1",100],["2008-2",150],["2008-3",189],["2008-4",300],["2008-5",430],["2008-6",450],["2008-7",556]],{:title=>"Active",:start_date=>Time.mktime(2008,1,1),:items=>8})
  users=OpenFlashChartLazy::Serie.new([["2008-1",1000],["2008-2",1150],["2008-3",2189],["2008-4",2543],["2008-5",2800],["2008-6",3231],["2008-7",3429]],{:title=>"Registered",:start_date=>Time.mktime(2008,1,1),:items=>8})

  line_graph.add_serie(active_users)
  line_graph.add_serie(users)
  line_graph.x_axis.labels.rotate="vertical"
  line_graph.bg_colour="#FFFFFF"
  line_graph.x_axis.colour="#808080"
  line_graph.x_axis["grid-colour"]="#A0A0A0"
  line_graph.x_axis.stroke=0.5

  line_graph.y_axis.colour="#808080"
  line_graph.y_axis.stroke=0.5
  line_graph.y_axis["grid-colour"]="#A0A0A0"
  line_graph.to_json
EOS

get '/',:layout=>"layout" do
  sass :ofc2
  haml :index,:locals=>{:pie=>pie,:bar=>bar,:line=>line,:bar3d=>bar3d}
end
get '/controller/:type' do
  case params[:type]
    when "pie"
      pie
    when "bar"
      bar
    when "bar3d"
      bar3d
    when "line"
      line
  end
end
get '/graphs/:type' do
  case params[:type]
  when "pie"
    eval pie
  when "bar"
    eval bar
  when "bar3d"
    eval bar3d
  when "line"
    eval line
  end
end
get '/support/' do
  haml :support
end
get '/samples/:type' do
  haml params[:type].to_sym
end
get '/stylesheets/ofc2.css' do
  header 'Content-Type' => 'text/css; charset=utf-8'
  sass :ofc2
end 
